package LATMOS::Accounts::Bases::Sql::User;

use 5.010000;
use strict;
use warnings;

use base qw(LATMOS::Accounts::Bases::Sql::objects);

our $VERSION = (q$Rev$ =~ /^Rev: (\d+) /)[0];

=head1 NAME

LATMOS::Ad - Perl extension for blah blah blah

=head1 SYNOPSIS

  use LATMOS::Accounts::Bases;
  my $base = LATMOS::Accounts::Bases->new('sql');
  ...

=head1 DESCRIPTION

Account base access over standard unix file format.

=head1 FUNCTIONS

=cut

=head2 new(%options)

Create a new LATMOS::Ad object for windows AD $domain.

domain / server: either the Ad domain or directly the server

ldap_args is an optionnal list of arguments to pass to L<Net::LDAP>.

=cut

sub object_table { 'person' }

sub key_field { 'login' }

sub _inline_fields {
    my ($self, $for) = @_;
    my %fields = (
        uidNumber       => 'uid',
        gidNumber       => 'gid',
        (($for !~ /w/)
        ? (
            gecos        => 'gecos',
            sAMAccountName  => 'sAMAccountName',
        )
        : ()),
    );
    \%fields
}

sub get_field {
    my ($self, $field) = @_;
    if ($field eq 'gecos') {
        return join(' ', map { $_ || '' } ($self->get_c_field('givenName'), ($self->get_c_field('sn'))));
    } elsif ($field eq 'sAMAccountName') {
        return $self->{id},
    } else {
        return $self->SUPER::get_field($field);
    }
}

1;

__END__

=head1 SEE ALSO

=head1 AUTHOR

Olivier Thauvin, E<lt>olivier.thauvin@latmos.ipsl.frE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2008, 2009 CNRS SA/CETP/LATMOS

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.10.0 or,
at your option, any later version of Perl 5 you may have available.


=cut
